package pt.uc.dei.crf_ma.clustering;

import java.util.ArrayList;

public class HCluster {
	private static int nextClusterId = 1;
	private int clusterId;
	private ArrayList<String> instances;
	
	public HCluster() {
		this.clusterId = nextClusterId++;
		this.instances = new ArrayList<String>();
	}
	
	public HCluster(ArrayList<String> instances) {
		this.clusterId = nextClusterId++;
		this.instances = instances;
	}
	
	public void addInstance(String instance) {
		this.instances.add(instance);
	}

	public int getClusterId() {
		return clusterId;
	}

	public void setClusterId(int clusterId) {
		this.clusterId = clusterId;
	}

	public ArrayList<String> getInstances() {
		return instances;
	}

	public void setInstances(ArrayList<String> instances) {
		this.instances = instances;
	}
	
	public int getSize() {
		return this.instances.size();
	}

	@Override
	public String toString() {
		String s = "Cluster" + this.clusterId + "(";
		for (String instance : this.instances) {
			s += instance + ",";
		}
		s += ")";
		return s;
	}	
}
