/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package pt.uc.dei.crf_ma.pipe;

import cc.mallet.pipe.Pipe;
import cc.mallet.types.Instance;
import cc.mallet.types.Token;
import cc.mallet.types.TokenSequence;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.LineNumberReader;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Reader;
import java.io.Serializable;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * 
 * @author fmpr
 */
public class MySQLTokenLexiconMembership extends Pipe implements Serializable {
	String name;
	boolean ignoreCase;
	private String host = "localhost";
	private String db = "mydatabase";
	private String user = "username";
	private String passwd = "password";
	private String table = "table";
	private String column = "column";
	private Connection connection = null;

	public MySQLTokenLexiconMembership(String name, boolean ignoreCase, String host,
			String db, String user, String passwd, String table, String column) {
		this.name = name;
		this.ignoreCase = ignoreCase;
		this.host = host;
		this.db = db;
		this.user = user;
		this.passwd = passwd;
		this.table = table;
		this.column = column;
		if (!connectDB()) {
			throw new IllegalArgumentException("Unable to connect to database "
					+ db + " in host " + host + " for LexiconFeature " + name);
		}
	}

	private boolean connectDB() {
		try {
			// Load the JDBC driver
			String driverName = "com.mysql.jdbc.Driver"; // MySQL MM JDBC driver
			Class.forName(driverName);

			// Create a connection to the database
			String url = "jdbc:mysql://" + host + "/" + db; // a JDBC url
			System.out.println("Connecting to MySQL: " + url);
			this.connection = DriverManager.getConnection(url, user, passwd);
		} catch (ClassNotFoundException e) {
			// Could not find the database driver
			e.printStackTrace();
			return false;
		} catch (SQLException e) {
			// Could not connect to the database
			e.printStackTrace();
			return false;
		}
		return true;
	}

	public Instance pipe(Instance carrier) {
		TokenSequence ts = (TokenSequence) carrier.getData();
		for (int i = 0; i < ts.size(); i++) {
			Token t = ts.get(i);
			String s = t.getText();
			String conS = s;
			// dealing with ([a-z]+), ([a-z]+, [a-z]+), [a-z]+.
			if (conS.startsWith("("))
				conS = conS.substring(1);
			if (conS.endsWith(")") || conS.endsWith("."))
				conS = conS.substring(0, conS.length() - 1);

			// Search the database for the token
			String query = null;
			if(ignoreCase) {
				query = "SELECT " + column + " FROM " + table + " WHERE lower(" + column + ") = '" + s.toLowerCase() + "';";
			} else {
				query = "SELECT " + column + " FROM " + table + " WHERE " + column + " = '" + s + "';";
			}
			//System.out.println("query="+query);

			ResultSet rs = null;
	        try {
	            Statement stmt = connection.createStatement();
	            rs = stmt.executeQuery(query);
	            
	            if (rs != null && rs.next()) {
		        	t.setFeatureValue(name, 1.0);
		        }
	        } catch (SQLException ex) {
	            ex.printStackTrace();
	        }
			
//			if (lexicon.contains(ignoreCase ? s.toLowerCase() : s))
//				t.setFeatureValue(name, 1.0);
//			if (conS.compareTo(s) != 0) {
//				if (lexicon.contains(ignoreCase ? conS.toLowerCase() : conS))
//					t.setFeatureValue(name, 1.0);
//			}
		}
		return carrier;
	}

	// Serialization

	private static final long serialVersionUID = 1;
	private static final int CURRENT_SERIAL_VERSION = 0;

	private void writeObject(ObjectOutputStream out) throws IOException {
		out.writeInt(CURRENT_SERIAL_VERSION);
		out.writeObject(name);
		out.writeObject(host);
		out.writeObject(db);
		out.writeObject(user);
		out.writeObject(passwd);
		out.writeObject(table);
		out.writeObject(column);
		out.writeBoolean(ignoreCase);
	}

	private void readObject(ObjectInputStream in) throws IOException,
			ClassNotFoundException {
		int version = in.readInt();
		this.name = (String) in.readObject();
		this.host = (String) in.readObject();
		this.db = (String) in.readObject();
		this.user = (String) in.readObject();
		this.passwd = (String) in.readObject();
		this.table = (String) in.readObject();
		this.column = (String) in.readObject();
		this.ignoreCase = in.readBoolean();
	}
}
